"""ECG waveform for Android"""
__copyright__ = '(c) 2011 Emant Pte Ltd'
__license__ = 'Apache License, Version 2.0'

import android
import time
import json
import random
import math
import threading
import emant

droid = android.Android()
droid.webViewShow('file:///sdcard/sl4a/scripts/graph.html')

droid.addOptionsMenuItem("Start","check","Start")
droid.addOptionsMenuItem("Stop","check","Stop")
droid.addOptionsMenuItem("Quit","check","Quit")

MAINS_FREQ = 50
NOTCH_LENGTH_AVERAGE = 4
ScanRate = MAINS_FREQ * NOTCH_LENGTH_AVERAGE
NumSamples = ScanRate * 2 + NOTCH_LENGTH_AVERAGE 

def NotchMains(ECGdata):
    filteredECG=[]
    for i in range(len(ECGdata)-NOTCH_LENGTH_AVERAGE):
        filteredECG.append([i,(sum(ECGdata[i:(i+NOTCH_LENGTH_AVERAGE)])/NOTCH_LENGTH_AVERAGE)])
    return filteredECG

m = emant.Emant300()
m.Open("00:06:66:00:A1:D8",True)
r,actScanRate = m.ConfigAnalog(1, emant.Emant300.Bipolar, ScanRate)

f=False
loop=True
readAvail=False
notReadStart=True
reading=[]

def myloop():
    global reading, readAvail, notReadStart, m, NumSamples
    notReadStart=False
    ECGdata = m.ReadAnalogWaveform(emant.Emant300.AIN2,emant.Emant300.AIN3, NumSamples)
    reading = NotchMains(ECGdata)
    readAvail=True
    notReadStart=True


while loop:
    e = droid.eventWaitFor('check',200).result
    if (e):
        droid.makeToast(e['data'])
        f = (e['data']=="Start")
        loop = not(e['data']=="Quit")
    if (f):
        if (readAvail):
            droid.eventPost("respond",json.dumps(reading))
            readAvail=False
        if (notReadStart):
            t=threading.Thread(target=myloop)
            t.start()

time.sleep(2)
m.Close()

     

